首页 > 编程学习 > 第十二章 systemctl管理脚本

第十二章 systemctl管理脚本

发布时间:2022/9/21 10:41:13

一、介绍

1.systemctl脚本存放在:/usr/lib/systemd/,有系统(system)和用户(user)之分
	1)/usr/lib/systemd/system #系统服务,开机不需要登陆就能运行的程序(相当于开启自启)
	2)/usr/lib/systemd/user #用户服务,需要登录后才能运行的程序

2./usr/lib/systemd/目录下又存在两种类型的文件
	1)*.service # 服务unit文件
	2)*.target # 开机级别unit
	
3.centos7 的每一个服务以。service 结尾,一般分为3部分:【unit】、【service】、【install】
[Unit]  # 主要是服务说明
Description=test  # 简单描述服务
After=network.target # 描述服务类别,表示本服务需要在network服务启动后在启动
Before=xxx.service #表示需要在某些服务启动之前启动,After和Before字段只涉及启动顺序,不涉
及依赖关系。
[Service]  # 核心区域
Type=forking   # 表示后台运行模式。
User=user     # 设置服务运行的用户
Group=user    # 设置服务运行的用户组
KillMode=control-group  # 定义systemd如何停止服务
PIDFile=/usr/local/test/test.pid   # 存放PID的绝对路径
Restart=no     # 定义服务进程退出后,systemd的重启方式,默认是不重启
ExecStart=/usr/local/test/bin/startup.sh   # 服务启动命令,命令需要绝对路径
PrivateTmp=true                # 表示给服务分配独立的临时空间
[Install] 
WantedBy=multi-user.target  # 多用户

二、字段详细说明

1)type类型

simple(默认):#以Execstart字段启动的进程为主进程
forking:#Execstart 字段以fox()方式启动,,此时父进程将退出,子进程将成为主进程(后台运
行),一般都设置为forking
oneshot : #类似于simple,但只执行一次,systemd会等他执行完,才执行其他服务
dbus: #类似于simple,但会等待D—Bus信号后启动
notify: #类似与simple ,但结束后会发出通知信号,然后systemd才启动其他服务
idle: #类似与simple,但要等到其他任务都执行完,才启动该服务

2)EnvironmentFile

EnvironmentFile:指定配置文件,和连词号组合使用,可以避免配置文件不存在的异常。

Environment:
后面接多个不同的shell变量。
例如:
Environment=DATA_DIR=/data/elk
Environment=LOG_DIR=/var/log/elasticsearch
Environment=PID_DIR=/var/run/elasticsearch
EnvironmentFile=-/etc/sysconfig/elasticsearch
连词号(-):在所有启动设置之前,添加的变量字段,都可以加上连词号
表示抑制错误,即发生错误时,不影响其他命令的执行。
比如EnviromentFile=-/etc/sysconfig/xxx表示即使文件不存在,也不会抛异常

3)Killmode的类型

contorl-group (默认) # 当前控制组里所有的子进程都会被杀掉

process : #只杀主进程

mixed: #主进程将收到SIGTERM(终止进程)信号,子进程将收到SIGKILL(无条件终止)信号

none: # 没有进程会被杀掉,只是执行服务的stop命令

4)Restart类型

no (默认):#退出后无操作
 on-success :#只有正常退出时(退出状态码为0),才会重启
 on-failure: #非正常退出时,重启,包括信号终止,和超时
 on-abnaomal:  #只有信号终止或超时,才会重启
 on-abort : #只有在收到没有捕捉到信号终止时,才会重启
 on-watchdog: #超市退出时,才会重启
 always: #不管什么退出原因,都会重启
 #对于守护进程,推荐使用on-failure

5)RestartSec

表示systemd重启服务之前,需要等待的秒数:RestartSec:30

6)各种Exec*字段

Exec*后面的命令,仅接受‘指令 参数 参数..’格式,不能接受<> |&等特殊字符,很多bash语法也不支
持,如果想要支持bash语法,需要设置Tyep=oneshot
# ExecStart:  # 启动服务时执行的命令
# ExecReload:  # 重启服务时执行的命令
# ExecStop:   # 停止服务时执行的命令
# ExecStartPre: # 启动服务前执行的命令
# ExecStartPost:# 启动服务后执行的命令
# ExecStopPost: # 停止服务后执行的命令
# PrivateTmp=True #表示给服务分配独立的临时空间,
# 注意:[Service]部分的启动、重启、停止命令全部要求使用绝对路径,使用相对路径则会报错!
[Service]
Type=forking
PIDFile=/home/developer/web/gunicorn.pid
ExecStart=/usr/local/bin/forever start
ExecReload=/bin/kill -s HUP $MAINPID
ExecStop=/bin/kill -s QUIT $MAINPID
PrivateTmp=true

7)[Install]部分

[Install]部分是服务安装的相关设置,可设置为多用户的

[Install]
WantedBy=multi-user.target
# WantedBy字段:
# multi-user.target: # 表示多用户命令行状态,这个设置很重要
# graphical.target: # 表示图形用户状体,它依赖于multi-user.target


修改配置文件以后,以754的权限保存在/usr/lib/systemd/system目录下,需要重新加载配置文件方可生效

$ systemctl daemon-reload

这时就可以利用systemctl进行配置了
首先,使用systemctl start [服务名(也是文件名)]可测试服务是否可以成功运行,如果不能运行则可以使用systemctl status [服务名(也是文件名)]查看错误信息和其他服务信息,然后根据报错进行修改,直到可以start,如果不放心还可以测试restart和stop命令。

接着,只要使用systemctl enable xxxxx就可以将所编写的服务添加至开机启动即可。

三、实操

1)编写nginx启动脚本

编写脚本如下,并且保证脚本有可执行权限

[root@aliyun ~]# cat nginx.sh
#!/bin/bash
. /etc/init.d/functions
args=$1
fun(){
 [ $? -eq 0 ] && action "Nginx $args is " /bin/true  || echo "Nginx $args is
" /bin/false
}
case $1 in
 start)
   netstat -lntup|grep  ":8080\b" &>/dev/null
   if [ $? -eq 0 ]
   then
     echo "Nginx is runing..."
   else
     /usr/local/nginx/sbin/nginx
     fun
   fi
   ;;
 stop)
   /usr/local/nginx/sbin/nginx -s stop
   fun
   ;;
 reload)
   /usr/local/nginx/sbin/nginx -s reload
   fun
   ;;
 restart)
   netstat -lntup|grep  ":8800\b" &>/dev/null
   if [ $? -ne 0 ]
   then
     /usr/local/nginx/sbin/nginx
    [ $? -eq 0 ] && echo "Nginx start is ok" || echo "Nginx start is
failed"
   else
     /usr/local/nginx/sbin/nginx -s stop              
    [ $? -eq 0 ] && echo "Nginx stop is ok" || echo "Nginx stop is failed"
     sleep 2
     /usr/local/nginx/sbin/nginx
     fun
   fi
   ;;
 status)
   netstat -lntup|grep  ":8080\b" &>/dev/null
   if [ $? -eq 0 ]
   then
     echo "Nginx is runing ..."
   else
     echo "Nginx is not runing ..."
   fi
   ;;
  *)
    echo "Usage: $0 {start|stop|status|restart|reload}"
    exit 2
esac
[root@aliyun ~]# chmod +x nginx.sh

2)配置

[root@aliyun ~]# cat /usr/lib/systemd/system/nginx.service
[Unit]
Description=Nginx server daemon
[Service]
Type=forking
ExecStart=/root/nginx.sh start
ExecStop=/root/nginx.sh stop
ExecReload=/root/nginx.sh reload
PrivateTmp=true
[Install]
WantedBy=multi-user.target

3)重新加载

systemctl daemon-reload

4)测试

[root@aliyun ~]# systemctl start nginx
[root@aliyun ~]# systemctl status nginx
● nginx.service - Nginx server daemon
 Loaded: loaded (/usr/lib/systemd/system/nginx.service; disabled; vendor
preset: disabled)
 Active: active (running) since Mon 2020-08-24 00:10:44 CST; 1s ago
 Process: 4166 ExecStart=/root/nginx.sh start (code=exited, status=0/SUCCESS)
Main PID: 4173 (nginx)
 CGroup: /system.slice/nginx.service
     ├─4173 nginx: master process /usr/local/nginx/sbin/nginx
     └─4175 nginx: worker process
Aug 24 00:10:44 aliyun systemd[1]: Starting Nginx server daemon...
Aug 24 00:10:44 aliyun nginx.sh[4166]: Nginx start is [  OK ]
Aug 24 00:10:44 aliyun systemd[1]: Started Nginx server daemon.
[root@aliyun ~]# systemctl reload nginx
[root@aliyun ~]# systemctl status nginx
● nginx.service - Nginx server daemon
 Loaded: loaded (/usr/lib/systemd/system/nginx.service; disabled; vendor
preset: disabled)
 Active: active (running) since Mon 2020-08-24 00:10:44 CST; 13s ago
 Process: 4186 ExecReload=/root/nginx.sh reload (code=exited, status=0/SUCCESS)
 Process: 4166 ExecStart=/root/nginx.sh start (code=exited, status=0/SUCCESS)
Main PID: 4173 (nginx)
 CGroup: /system.slice/nginx.service
     ├─4173 nginx: master process /usr/local/nginx/sbin/nginx
     └─4193 nginx: worker process
Aug 24 00:10:44 aliyun systemd[1]: Starting Nginx server daemon...
Aug 24 00:10:44 aliyun nginx.sh[4166]: Nginx start is [  OK ]
Aug 24 00:10:44 aliyun systemd[1]: Started Nginx server daemon.
Aug 24 00:10:56 aliyun systemd[1]: Reloading Nginx server daemon.
Aug 24 00:10:56 aliyun nginx.sh[4186]: Nginx reload is [  OK ]
Aug 24 00:10:56 aliyun systemd[1]: Reloaded Nginx server daemon.

四、练习

把下述脚本sync.sh添加到systemctl

#!/bin/bash
case $1 in
start)
ps -ef|grep [s]ersync &>/dev/null
if [ $? -eq 0 ]
then
action "sersync is running..."  /bin/true
else
/usr/local/sersync/bin/sersync -dro /usr/local/sersync/conf/confxml.xml
&>/dev/null
[ $? -eq 0 ] && action "sersync start is " /bin/true || action "sersync
start is" /bin/false
fi
;;
stop)
ps -ef|grep [s]ersync &>/dev/null
if [ $? -eq 0 ]
then
Pid_num=$(ps -ef|grep [s]ersync|awk '{print $2}')
kill $Pid_num
ps -ef|grep [s]ersync &>/dev/null
[ $? -ne 0 ] && action "sersync stop is"  /bin/true  || action "sersync
stop is"  /bin/false
else
action "sersync is not runing ... "  /bin/false
fi
esac

测试
systemctl  daemon-reload
systemctl  start sersync
systemctl  stop sersync

五、进程锁

防止进程被重复运行

[root@aliyun ~]# cat lock.sh
#!/bin/bash
lock_file=/tmp/echo1.lock
#判断进程是否正在运行
if [ -f $lock_file ];then
pid=`cat $lock_file`
ps $pid &>/dev/null
[ $? -eq 0 ] && echo "Script1 is running..." && exit 1
#if [ $? -eq 0 ];then
# echo "Script1 is running..."
# exit 1
#fi
fi
#创建锁
echo $$ > $lock_file
echo "lock1 begin..."
sleep 500
echo "lock1 end"
#释放锁
rm -rf $lock_file

Copyright © 2010-2022 mfbz.cn 版权所有 |关于我们| 联系方式|豫ICP备15888888号